﻿//DESCRIPTION: Attach 2-lines of text to Ellipse

(function() {
	if (app.documents.length > 0 &&
			app.selection.length > 0) {
		var msg = "Please select one 2-line text frame and an ellipse.";
		if (app.selection.length != 2) { alert(msg); return; }
		var theObjs = getObjects(app.selection);
		if (theObjs == null) { alert(msg); return; }
		var textFrame = theObjs.tf;
		var firstOval = theObjs.ov;
		var secondOval = firstOval.duplicate(undefined, [0,0]);
		firstOval.parent.groups.add([firstOval, secondOval]);
		firstOval.insertLabel("TFloc", textFrame.geometricBounds.toSource());
		secondOval.insertLabel("TFloc", textFrame.geometricBounds.toSource());
		var proxy = app.activeWindow.transformReferencePoint;
		app.activeWindow.transformReferencePoint = AnchorPoint.centerAnchor;
		secondOval.rotationAngle = 180;
		app.activeWindow.transformReferencePoint = proxy;
		firstPath = firstOval.textPaths.add();
		var adj = (firstPath.endBracket - firstPath.startBracket)/4;
		firstPath.startBracket += adj;
		firstPath.endBracket -= adj;
		textFrame.texts[0].lines[0].move(LocationOptions.atEnd, firstPath.texts[0]);
		firstPath.texts[0].justification = Justification.centerAlign;
		secondPath = secondOval.textPaths.add();
		textFrame.texts[0].move(LocationOptions.atEnd, secondPath.texts[0]);
		secondPath.texts[0].justification = Justification.centerAlign;
		secondPath.flipPathEffect = FlipValues.flipped;
		var newEnd = secondPath.startBracket;
		secondPath.startBracket = secondPath.endBracket;
		secondPath.endBracket = newEnd;
		firstPath.textAlignment = TextTypeAlignments.descenderTextAlignment;
		secondPath.textAlignment = TextTypeAlignments.ascenderTextAlignment;
		secondPath.previousTextFrame = firstPath;
		textFrame.remove();
	}
	function getObjects(sel) {
		// Need one text frame with 2 lines of text and one oval
		// Page item can't be a group
		var myObjs = {tf:null, ov:null}
		for (var j = 0; sel.length > j; j++) {
			if (sel[j] instanceof TextFrame) {
				if (sel[j].lines.length == 2) {
					myObjs.tf = sel[j];
				}
			} else if (sel[j] instanceof Oval) {
				myObjs.ov = sel[j];
			}
		}
		if (myObjs.tf != null && myObjs.ov != null) {
			return myObjs;
		}
	}
}())
